/* ======== psychoviewer_mm ========
* Copyright (C) 2004-2005 sslice
* No warranties of any kind
*
* License: zlib/libpng
*
* Author(s): James "sslice" Gray
* ============================
*/

#include <oslink.h>
#include "psychoviewer.h"
#include "cvars.h"
#include "MRecipientFilter.h"
#include "bitbuf.h"

PsychoViewer g_PsychoViewer;

PLUGIN_EXPOSE(PsychoViewer, g_PsychoViewer);

//This has all of the necessary hook declarations.  Read it!
#include "meta_hooks.h"

int iVGUIMenu;
int m_ClientIndex;

void str_ireplace(char *str, const char *from, const char *to, int maxlen)
{
  char  *pstr   = str;
  int   fromlen = Q_strlen(from);
  int   tolen   = Q_strlen(to);
  
  while (*pstr != '\0' && pstr - str < maxlen) {
    if (Q_strnicmp(pstr, from, fromlen) != 0) {
      *pstr++;
      continue;
    }
    Q_memmove(pstr + tolen, pstr + fromlen, maxlen - ((pstr + tolen) - str) - 1);
    Q_memcpy(pstr, to, tolen);
    pstr += tolen;
  }
}

CreateInterfaceFn* findInterface(CreateInterfaceFn fac, const char *inter, unsigned int offset) {
   if (fac==NULL || inter==NULL || offset ==0) return NULL;
   CreateInterfaceFn *temp;
   temp = (CreateInterfaceFn*)fac(inter,NULL);
   if (temp) return temp;
   else
   {
      int sLenName=strlen(inter);
      char intName[256], newVer[256];
      Q_memcpy(intName,inter,(sLenName>256?256:sLenName));
      unsigned int cVersion;
      cVersion = intName[sLenName-1]+(intName[sLenName-2]*10)+(intName[sLenName-3]*100);
      cVersion = atoi(&intName[sLenName-3]);
      intName[sLenName-3] = 0;
      for (cVersion = cVersion+offset;(cVersion>cVersion - offset && cVersion > 0); cVersion--)
	  {
         Q_snprintf(newVer,256,"%s%03d",intName,cVersion);
         temp = (CreateInterfaceFn *)fac(newVer,NULL);
         if (temp) return temp;
      }
   }
   return NULL;
}

// CVARs
ConVar g_PluginVersion("psychoviewer_version", PLUGIN_VERSION, FCVAR_SPONLY, "PsychoViewer version");

//bool PsychoViewer::LevelInit(const char *pMapName, const char *pMapEntities, const char *pOldLevel, const char *pLandmarkName, bool loadGame, bool background)
//{
//	RETURN_META_VALUE(MRES_IGNORED, true);
//}

//void PsychoViewer::OnLevelShutdown()
//{
//}

void PsychoViewer::ServerActivate(edict_t *pEdictList, int edictCount, int clientMax)
{
	iVGUIMenu = UserMessageIndex("VGUIMenu");

	LoadWebLinks();

	RETURN_META(MRES_IGNORED);
}

//void PsychoViewer::GameFrame(bool simulating)
//{
//	//don't log this, it just pumps stuff to the screen ;]
//	//META_LOG(g_PLAPI, "GameFrame() called: simulating=%d", simulating);
//	RETURN_META(MRES_IGNORED);
//}

//void PsychoViewer::LevelShutdown( void )
//{
//	RETURN_META(MRES_IGNORED);
//}

//void PsychoViewer::ClientActive(edict_t *pEntity, bool bLoadGame)
//{
//	RETURN_META(MRES_IGNORED);
//}

//void PsychoViewer::ClientDisconnect(edict_t *pEntity)
//{
//	RETURN_META(MRES_IGNORED);
//}

//void PsychoViewer::ClientPutInServer(edict_t *pEntity, char const *playername)
//{
//	RETURN_META(MRES_IGNORED);
//}

void PsychoViewer::SetCommandClient(int index)
{
	m_ClientIndex = index + 1;
	RETURN_META(MRES_IGNORED);
}

//void PsychoViewer::ClientSettingsChanged(edict_t *pEdict)
//{
//	RETURN_META(MRES_IGNORED);
//}

//bool PsychoViewer::ClientConnect(edict_t *pEntity, const char *pszName, const char *pszAddress, char *reject, int maxrejectlen)
//{
//	RETURN_META_VALUE(MRES_IGNORED, true);
//}

//void PsychoViewer::ClientCommand(edict_t *pEntity)
//{
//	const char *pcmd = m_Engine->Cmd_Argv(0);
//
//	RETURN_META(MRES_IGNORED);
//}
void PsychoViewer::ChatHook()
{
	const char *ptext = m_Engine->Cmd_Argv(1);
	if (Q_strncmp(ptext,"/url ",5) == 0 && Q_strlen(ptext) > 5) {
		char url [255];
		memset(url,0,255);
		int pos = 0;
		for (int x = 5; ptext[x] != 0; x++) {
			url[pos] = ptext[x];
			pos++;
		}
		if (Q_strlen(url) > 0)
			ShowWebLink(m_Engine->PEntityOfEntIndex(m_ClientIndex),url);
		RETURN_META(MRES_SUPERCEDE);
	}
	else {
		char word [255], args [255];
		memset(word,0,255);
		memset(args,0,255);
		int y;
		bool bword = true;
		int length = strlen(ptext);
		for (int x = 0; x != length; x++) {
			if (bword) {
				if (ptext[x] == ' ') { bword = false; y = 0; continue; }
				word[x] = ptext[x];
			}
			else {
				args[y] = ptext[x];
				if (ptext == 0) break;
				y++;
			}
		}
		CVector<WebLink*>::iterator it;
		for (it = vWebLinks.begin(); it != vWebLinks.end(); it++) {
			if (*it && Q_stricmp(word,(*it)->GetKeyword()) == 0) {
				edict_t *pEntity = m_Engine->PEntityOfEntIndex(m_ClientIndex);
				char url [255], id [10], name [64], steam [64];
				Q_strncpy(steam,m_Engine->GetPlayerNetworkIDString(pEntity),64);
				Q_snprintf(id,10,"%d",m_Engine->GetPlayerUserId(pEntity));
				Q_strncpy(name,m_Engine->GetClientConVarValue(m_ClientIndex,"name"),64);
				strcpy(url,(*it)->GetURL());
				str_ireplace(url,"{text}",args,255);
				str_ireplace(url,"{steam}",steam,255);
				str_ireplace(url,"{id}",id,255);
				str_ireplace(url,"{name}",name,255);
				ShowWebLink(pEntity,url);
				break;
			}
		}
	}
	RETURN_META(MRES_IGNORED);
}
//bool PsychoViewer::FireGameEvent(IGameEvent *event, bool bDontBroadcast)
//{
//	if (!event || !event->GetName())
//		RETURN_META_VALUE(MRES_IGNORED, false);
//
//	const char *name = event->GetName();
//
//	RETURN_META_VALUE(MRES_IGNORED, true);
//}

bool PsychoViewer::Load(PluginId id, ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	PLUGIN_SAVEVARS();

	m_ServerDll = (IServerGameDLL *)findInterface(ismm->serverFactory(), INTERFACEVERSION_SERVERGAMEDLL, 3);
	m_Engine = (IVEngineServer *)findInterface(ismm->engineFactory(), INTERFACEVERSION_VENGINESERVER, 3);
	m_ServerClients = (IServerGameClients *)findInterface(ismm->serverFactory(), INTERFACEVERSION_SERVERGAMECLIENTS, 3);
	//m_GameEventManager = (IGameEventManager2 *)((ismm->engineFactory())(INTERFACEVERSION_GAMEEVENTSMANAGER2, NULL));
	m_ICvar = (ICvar *)findInterface(ismm->engineFactory(), VENGINE_CVAR_INTERFACE_VERSION, 3);

	if (!m_ICvar)
	{
		Q_snprintf(error, maxlen, "Could not find interface %s", VENGINE_CVAR_INTERFACE_VERSION);
		return false;
	}
	if (!m_ServerDll)
	{
		Q_snprintf(error, maxlen, "Could not find interface %s", INTERFACEVERSION_SERVERGAMEDLL);
		return false;
	}
	if (!m_Engine)
	{
		Q_snprintf(error, maxlen, "Could not find interface %s", INTERFACEVERSION_VENGINESERVER);
		return false;
	}
	if (!m_ServerClients)
	{
		Q_snprintf(error, maxlen, "Could not find interface %s", INTERFACEVERSION_SERVERGAMECLIENTS);
		return false;
	}
	//if (!m_GameEventManager)
	//{
	//	Q_snprintf(error, maxlen, "Could not find interface %s", INTERFACEVERSION_GAMEEVENTSMANAGER2);
	//	return false;
	//}

	//Init our cvars/concmds
	ConCommandBaseMgr::OneTimeInit(&g_Accessor);

	//We're hooking the following things as POST, in order to seem like Server Plugins.
	//However, I don't actually know if Valve has done server plugins as POST or not.
	//Change the last parameter to 'false' in order to change this to PRE.
	//SH_ADD_HOOK_MEMFUNC means "SourceHook, Add Hook, Member Function".

	//Hook LevelInit to our function
	//SH_ADD_HOOK_MEMFUNC(IServerGameDLL, LevelInit, m_ServerDll, &g_PsychoViewer, &PsychoViewer::LevelInit, true);
	//Hook ServerActivate to our function
	SH_ADD_HOOK_MEMFUNC(IServerGameDLL, ServerActivate, m_ServerDll, &g_PsychoViewer, &PsychoViewer::ServerActivate, true);
	//Hook GameFrame to our function
	//SH_ADD_HOOK_MEMFUNC(IServerGameDLL, GameFrame, m_ServerDll, &g_PsychoViewer, &PsychoViewer::GameFrame, true);
	//Hook LevelShutdown to our function -- this makes more sense as pre I guess
	//SH_ADD_HOOK_MEMFUNC(IServerGameDLL, LevelShutdown, m_ServerDll, &g_PsychoViewer, &PsychoViewer::LevelShutdown, false);
	//Hook ClientActivate to our function
	//SH_ADD_HOOK_MEMFUNC(IServerGameClients, ClientActive, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientActive, true);
	//Hook ClientDisconnect to our function
	//SH_ADD_HOOK_MEMFUNC(IServerGameClients, ClientDisconnect, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientDisconnect, true);
	//Hook ClientPutInServer to our function
	//SH_ADD_HOOK_MEMFUNC(IServerGameClients, ClientPutInServer, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientPutInServer, true);
	//Hook SetCommandClient to our function
	SH_ADD_HOOK_MEMFUNC(IServerGameClients, SetCommandClient, m_ServerClients, &g_PsychoViewer, &PsychoViewer::SetCommandClient, true);
	//Hook ClientSettingsChanged to our function
	//SH_ADD_HOOK_MEMFUNC(IServerGameClients, ClientSettingsChanged, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientSettingsChanged, true);

	//The following functions are pre handled, because that's how they are in IServerPluginCallbacks

	//Hook ClientConnect to our function
	//SH_ADD_HOOK_MEMFUNC(IServerGameClients, ClientConnect, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientConnect, false);
	//Hook ClientCommand to our function
	//SH_ADD_HOOK_MEMFUNC(IServerGameClients, ClientCommand, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientCommand, false);

	//This hook is a static hook, no member function
	//SH_ADD_HOOK_MEMFUNC(IGameEventManager2, FireEvent, m_GameEventManager, &g_PsychoViewer, &PsychoViewer::FireGameEvent, false);


	//Get the call class for IVServerEngine so we can safely call functions without
	// invoking their hooks (when needed).
	m_Engine_CC = SH_GET_CALLCLASS(m_Engine);

	SH_CALL(m_Engine_CC, &IVEngineServer::LogPrint)("All hooks started!\n");

	if (late) {
		LoadWebLinks();
		// Hook say/say_team commands
		ConCommandBase *pCmd = m_ICvar->GetCommands();
		while (pCmd)
		{
			if (pCmd->IsCommand() && (strcmp(pCmd->GetName(), "say") == 0))
				break;
			pCmd = const_cast<ConCommandBase *>(pCmd->GetNext());
		}
		if (pCmd)
		{
			pSayCmd = (ConCommand *)pCmd;
			SH_ADD_HOOK_MEMFUNC(ConCommand, Dispatch, pSayCmd, &g_PsychoViewer, &PsychoViewer::ChatHook, false);
		}
		else pSayCmd = NULL;

		pCmd = m_ICvar->GetCommands();
		while (pCmd)
		{
			if (pCmd->IsCommand() && (strcmp(pCmd->GetName(), "say_team") == 0))
				break;
			pCmd = const_cast<ConCommandBase *>(pCmd->GetNext());
		}
		if (pCmd)
		{
			pTeamSayCmd = (ConCommand *)pCmd;
			SH_ADD_HOOK_MEMFUNC(ConCommand, Dispatch, pTeamSayCmd, &g_PsychoViewer, &PsychoViewer::ChatHook, false);
		} 
		else pTeamSayCmd = NULL;
	}

	return true;
}

bool PsychoViewer::Unload(char *error, size_t maxlen)
{
	//IT IS CRUCIAL THAT YOU REMOVE CVARS.
	//As of Metamod:Source 1.00-RC2, it will automatically remove them for you.
	//But this is only if you've registered them correctly!
    
	//Make sure we remove any hooks we did... this may not be necessary since
	//SourceHook is capable of unloading plugins' hooks itself, but just to be safe.

	//SH_REMOVE_HOOK_MEMFUNC(IGameEventManager2, FireEvent, m_GameEventManager, &g_PsychoViewer, &PsychoViewer::FireGameEvent, false); 
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameDLL, LevelInit, m_ServerDll, &g_PsychoViewer, &PsychoViewer::LevelInit, true);
	SH_REMOVE_HOOK_MEMFUNC(IServerGameDLL, ServerActivate, m_ServerDll, &g_PsychoViewer, &PsychoViewer::ServerActivate, true);
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameDLL, GameFrame, m_ServerDll, &g_PsychoViewer, &PsychoViewer::GameFrame, true);
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameDLL, LevelShutdown, m_ServerDll, &g_PsychoViewer, &PsychoViewer::LevelShutdown, false);
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameClients, ClientActive, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientActive, true);
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameClients, ClientDisconnect, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientDisconnect, true);
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameClients, ClientPutInServer, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientPutInServer, true);
	SH_REMOVE_HOOK_MEMFUNC(IServerGameClients, SetCommandClient, m_ServerClients, &g_PsychoViewer, &PsychoViewer::SetCommandClient, true);
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameClients, ClientSettingsChanged, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientSettingsChanged, true);
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameClients, ClientConnect, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientConnect, false);
	//SH_REMOVE_HOOK_MEMFUNC(IServerGameClients, ClientCommand, m_ServerClients, &g_PsychoViewer, &PsychoViewer::ClientCommand, false);

	//this, sourcehook does not keep track of.  we must do this.
	SH_RELEASE_CALLCLASS(m_Engine_CC);

	return true;
}

void PsychoViewer::AllPluginsLoaded()
{
	//we don't really need this for anything other than interplugin communication
	//and that's not used in this plugin.
	//If we really wanted, we could override the factories so other plugins can request
	// interfaces we make.  In this callback, the plugin could be assured that either
	// the interfaces it requires were either loaded in another plugin or not.

	// Hook say/say_team commands
	ConCommandBase *pCmd = m_ICvar->GetCommands();
	while (pCmd)
	{
		if (pCmd->IsCommand() && (strcmp(pCmd->GetName(), "say") == 0))
			break;
        pCmd = const_cast<ConCommandBase *>(pCmd->GetNext());
	}
	if (pCmd)
	{
		pSayCmd = (ConCommand *)pCmd;
		SH_ADD_HOOK_MEMFUNC(ConCommand, Dispatch, pSayCmd, &g_PsychoViewer, &PsychoViewer::ChatHook, false);
	}
	else pSayCmd = NULL;

	pCmd = m_ICvar->GetCommands();
	while (pCmd)
	{
		if (pCmd->IsCommand() && (strcmp(pCmd->GetName(), "say_team") == 0))
			break;
        pCmd = const_cast<ConCommandBase *>(pCmd->GetNext());
	}
	if (pCmd)
	{
		pTeamSayCmd = (ConCommand *)pCmd;
		SH_ADD_HOOK_MEMFUNC(ConCommand, Dispatch, pTeamSayCmd, &g_PsychoViewer, &PsychoViewer::ChatHook, false);
	} 
	else pTeamSayCmd = NULL;
}
int PsychoViewer::UserMessageIndex(const char *messageName)
{
   char name[128] = "";
   int sizereturn = 0;
   bool boolrtn = false;
   for(int x=1; x<22; x++)
   {
      boolrtn =  g_PsychoViewer.m_ServerDll->GetUserMessageInfo(x, name, 128, sizereturn); 
      if(name && Q_strcmp(messageName, name) == 0)
      {
         return x;     
      }
   }
   return -1;
}
void ShowViewPortPanel(edict_t* pEdict, const char* name, bool bShow, KeyValues* data)
{
	bf_write *netmsg; // our network message object
	MRecipientFilter recipient_filter; // the corresponding recipient filter

	// pPlayerEdict is a pointer to the edict of a player for which you want this HUD message
	// to be displayed. There can be several recipients in the filter, don't forget.
	recipient_filter.AddRecipient(g_PsychoViewer.m_Engine->IndexOfEdict(pEdict));

	int count = 0;
	KeyValues *subkey = NULL;

	if(data)
	{
		subkey = data->GetFirstSubKey();     
		while(subkey)
		{
			count++;     
			subkey = subkey->GetNextKey();
		}

		subkey = data->GetFirstSubKey(); // reset
	}
	netmsg = g_PsychoViewer.m_Engine->UserMessageBegin(&recipient_filter, iVGUIMenu);

	netmsg->WriteString (name); // the HUD message itself
	netmsg->WriteByte (bShow ? 1 : 0); // index of the player this message comes from. "0" means the server.
	netmsg->WriteByte (count); // I don't know yet the purpose of this byte, it can be 1 or 0
	    
	// write additional data (be carefull not more than 192 bytes!)
	while(subkey)
	{
		netmsg->WriteString (subkey->GetName()); // the HUD message itself
		netmsg->WriteString (subkey->GetString()); // the HUD message itself
		subkey = subkey->GetNextKey();
	}

	g_PsychoViewer.m_Engine->MessageEnd();
}
void PsychoViewer::ShowWebLink(edict_t *pEntity, const char *url)
{
   KeyValues* kv = new KeyValues("data");
   char title [32];
   Q_snprintf(title,32,"PsychoViewer %s",PLUGIN_VERSION);
   kv->SetString("title",title);   // info panel title
   kv->SetString("type","2");
                              //   TYPE_TEXT = 0,   // just display this plain text
                              //   TYPE_INDEX,      // lookup text & title in stringtable
                              //   TYPE_URL,      // show this URL
                              //   TYPE_FILE,      // show this local file

   kv->SetString("msg",url);

   kv->SetString("cmd", "");// exec this command if panel closed

   ShowViewPortPanel(pEntity, "info", true, kv);

   kv->deleteThis();
}
void PsychoViewer::LoadWebLinks() {
	FILE *fp;
    char file [255];

	m_Engine->GetGameDir(file,255);
#ifdef WIN32
	strncat(file,"\\addons\\psychoviewer\\cfg\\links.ini",255);
#else
	strncat(file,"/addons/psychoviewer/cfg/links.ini",255);
#endif

	fp = fopen(file, "rt");
	if (!fp)
	{
		Msg("ERROR: PsychoViewer could not open links file: %s\n", file);
		return;
	}

	char buffer[512], word [255], url [255];
	bool bword;
	int y, links = 0;
	memset(buffer,0,512);
	memset(word,0,255);
	memset(url,0,255);
	size_t length;

	vWebLinks.clear();
	while (!feof(fp))
	{
		bword = true;
		buffer[0] = 0;
		word[0] = 0;
		url[0] = 0;
		fgets(buffer, sizeof(buffer)-1, fp);
		length = Q_strlen(buffer);
		if (!length)
			continue;
		if (buffer[length-1] == '\n')
			buffer[length-1] = '\0';

		UTIL_TrimLeft(buffer);
		UTIL_TrimRight(buffer);

		if (buffer[0] == '\0' || buffer[0] == ';' || strncmp(buffer, "//", 2) == 0)
			continue;
		
		// Parse word and url
		for (int x = 0; x != length; x++) {
			if (bword) {
				if (buffer[x] == ' ') { bword = false; y = 0; continue; }
				word[x] = buffer[x];
			}
			else {
				url[y] = buffer[x];
				if (buffer[x] == 0) break;
				y++;
			}
		}

		// Add the web link
		if (Q_strlen(word) > 0 && Q_strlen(url) > 0) {
			WebLink* link = new WebLink();
			link->SetKeyword(word);
			link->SetURL(url);
			vWebLinks.push_back(link);
			links++;
		}
	}
	fclose(fp);

	Msg("PsychoViewer loaded %d link(s)\n",links);
}


/* UTIL_TrimLeft
 * Removes whitespace characters from left side of string
 */
void UTIL_TrimLeft(char *buffer)
{
	// Let's think of this as our iterator
	char *i = buffer;

	// Make sure the buffer isn't null
	if (i && *i)
	{
		// Add up number of whitespace characters
		while(isspace(*i))
			i++;

		// If whitespace chars in buffer then adjust string so first non-whitespace char is at start of buffer
		// :TODO: change this to not use memcpy()!
		if (i != buffer)
			memcpy(buffer, i, (Q_strlen(i) + 1) * sizeof(char));
	}
}
/* UTIL_TrimLeft
 * Removes whitespace characters from right side of string
 */
void UTIL_TrimRight(char *buffer)
{
	// Make sure buffer isn't null
	if (buffer)
	{
		// Loop through buffer backwards while replacing whitespace chars with null chars
		for (int i = (int)Q_strlen(buffer) - 1; i >= 0; i--)
		{
			if (isspace(buffer[i]))
				buffer[i] = '\0';
			else
				break;
		}
	}
}